'use strict';

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _webpackMerge = require('webpack-merge');

var _webpackMerge2 = _interopRequireDefault(_webpackMerge);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function configureHotModuleReplacement(config) {
  var webpackDevServerAddr = process.env['WEBPACK_DEV_SERVER_ADDR'] || 'http://localhost:8080/';
  config = (0, _webpackMerge2.default)(config, {
    output: {
      publicPath: webpackDevServerAddr // needed for HMR to know where to load the hot update chunks
    },
    plugins: [new _webpack2.default.NamedModulesPlugin()]
  });

  config.module.rules = config.module.rules.map(function (rule) {
    if (rule.loader === 'babel-loader') {
      return (0, _webpackMerge2.default)(rule, { options: { plugins: ['react-hot-loader/babel'] } });
    } else {
      return rule;
    }
  });

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = Object.keys(config.entry)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var key = _step.value;

      if (!(config.entry[key] instanceof Array)) {
        config.entry[key] = [config.entry[key]];
      }
      config.entry[key].unshift('react-hot-loader/patch');
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return config;
}

module.exports = configureHotModuleReplacement;